﻿<%@ WebHandler Language="C#" Class="GetPAMapCS" %>
using System;
using System.Configuration;
using System.Web;
using System.Net;

public class GetPAMapCS : IHttpHandler
{
   public void ProcessRequest(HttpContext context)
   {
    string mapURLStub = "http://www.postgis.us/mapservbin/mapserv.exe?map=";
    string mapfile = "c:/mapserver/maps/postgis_in_action.map";
    System.Net.HttpWebRequest WebRequestObject;
    System.IO.StreamReader sr;
    System.Net.HttpWebResponse WebResponseObject;
    System.Text.StringBuilder sb = new System.Text.StringBuilder();
	sb.Append(mapURLStub + mapfile);
      
    try {
        foreach (var key in context.Request.QueryString.AllKeys) {
           sb.Append("&" + key + "=" + context.Request.QueryString[key]);
        }
        
        WebRequestObject = (System.Net.HttpWebRequest) System.Net.WebRequest.Create(sb.ToString());
        WebRequestObject.Method = "GET";
        WebResponseObject = (System.Net.HttpWebResponse) WebRequestObject.GetResponse();
        if (context.Request["REQUEST"].ToLower() == "getcapabilities" || context.Request["REQUEST"].ToLower() == "getfeatureinfo") {
          //return xml if getcapabilities or getfeatureinfo
          sr = new System.IO.StreamReader(WebResponseObject.GetResponseStream());
          context.Response.ContentType = "application/xml";
          context.Response.Write(sr.ReadToEnd());
        }
        else {
           //assume an image is being returned
           context.Response.ContentType = context.Request["format"].ToString();
           System.IO.Stream outs = WebRequestObject.GetResponse().GetResponseStream();
           byte[] buffer = new byte[0x1000];
           int read;
           while ((read = outs.Read(buffer, 0, buffer.Length)) > 0)
           {
               context.Response.OutputStream.Write(buffer, 0, read);
           }
        }

        try {
           WebResponseObject.Close();
           WebRequestObject.Abort();
        }
        catch {
          
          
        }
       }
       catch (Exception Ex) {
        //assume it fails here if the web request fails
        context.Response.Write(Ex.ToString());
       }
  }
  
  public bool IsReusable {
     get { return true; }
  }   
}

